#include "ISprite_set.hxx"

using namespace ge211;
using namespace widgets;

void ISprite_set::add_sprite(Sprite const& sprite,
                                    Position position,
                                    int z)
{
    add_sprite(sprite, position, z, Transform{});
}

Sprite_set_adapter::Sprite_set_adapter(Sprite_set& adaptee)
        : adaptee_{adaptee}
{ }

void Sprite_set_adapter::add_sprite(ge211::Sprite const& sprite,
                                    ge211::Position position,
                                    int z,
                                    ge211::Transform transform)
{
    adaptee_.add_sprite(sprite, position, z, transform);
}

void Mock_sprite_set::add_sprite(ge211::Sprite const& sprite,
                                 ge211::Position position,
                                 int z,
                                 ge211::Transform transform)
{
    sprites.push_back({&sprite, position, z, transform});
}

void Sprite_set_layer::add_sprite(ge211::Sprite const& sprite,
                                  ge211::Position position,
                                  int z,
                                  ge211::Transform transform)
{
    zmin_ = std::min(zmin_, z);
    zmax_ = std::min(zmax_, z);
    sprites_.push_back({&sprite, position, z, transform});
}

int Sprite_set_layer::add_to(ISprite_set& set,
                             ge211::Dimensions xyoffset,
                             int z) const
{
    int zoffset = z - zmin_;
    int zfinal  = z + zmax_;

    for (const auto& placed : sprites_)
        set.add_sprite(*placed.sprite,
                       placed.position + xyoffset,
                       placed.z + zoffset,
                       placed.transform);

    return zfinal;
}

