#include "Widget.hxx"

using namespace ge211;
using namespace widgets;

Interactive_widget::Mouse_callback::
Mouse_callback(std::function<void(Position)> fn)
        : fn(fn)
{ }

Interactive_widget::Mouse_callback::
Mouse_callback(std::function<void()> fn)
        : fn([=](auto) { return fn(); })
{ }

void Interactive_widget::Mouse_callback::operator()(Position position)
{
    return fn(position);
}

void Interactive_widget::on_mouse_up(Mouse_callback f)
{
    on_mouse_up_ = f;
}

void Interactive_widget::on_mouse_down(Mouse_callback f)
{
    on_mouse_down_ = f;
}

void Interactive_widget::on_mouse_enter(Mouse_callback f)
{
    on_mouse_enter_ = f;
}

void Interactive_widget::on_mouse_leave(Mouse_callback f)
{
    on_mouse_leave_ = f;
}

void Interactive_widget::mouse_up(Position position)
{
    on_mouse_up_(position);
}

void Interactive_widget::mouse_down(Position position)
{
    on_mouse_down_(position);
}

void Interactive_widget::mouse_enter(Position position)
{
    on_mouse_enter_(position);
}

void Interactive_widget::mouse_leave(Position position)
{
    on_mouse_leave_(position);
}

static Color button_fg        = Color::black();

static Color button_bg        = Color::white();

static Color button_bg_hover  = Color::medium_blue().lighten(.5);

static Color button_bg_active = Color::medium_red().lighten(.5);

Button_widget::Button_widget(const std::string& label, int size)
        : sans_{"sans.ttf", size}
        , fg_{label, sans_}
        , bg_{{1, 1}, button_bg}
        , bg_hover_{{1, 1}, button_bg_hover}
        , bg_active_{{1, 1}, button_bg_active}
{ }
